From 04356549e94dacc57fd2db85a86a052906e2d90e Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Wed, 11 Apr 2012 18:25:36 -0700
Subject: [PATCH] Created first three 'scriptlets': * Dogtag 10: Python
 'instance_layout.py' Installation Scriptlet  
 (https://fedorahosted.org/pki/ticket/75) * Dogtag 10:
 Python 'webserver_layout.py' Installation Scriptlet  
 (https://fedorahosted.org/pki/ticket/140) * Dogtag 10:
 Python 'subsystem_layout.py' Installation Scriptlet  
 (https://fedorahosted.org/pki/ticket/141) Created numerous
 PKI deployment helper utilities. Augmented logging to
 provide indentation. Generated logic for installation
 'manifest'. Tested logic using '--dry_run' option and '-p'
 prefix options.

---
 base/deploy/CMakeLists.txt                       |   83 +++-
 base/deploy/config/pkideployment.cfg             |    3 +
 base/deploy/src/pkidestroy                       |   91 +++--
 base/deploy/src/pkispawn                         |  127 ++++--
 base/deploy/src/scriptlets/instance.py           |  105 ----
 base/deploy/src/scriptlets/instance_layout.py    |  124 +++++
 base/deploy/src/scriptlets/pkiconfig.py          |   41 ++-
 base/deploy/src/scriptlets/pkihelper.py          |  550 ++++++++++++++--------
 base/deploy/src/scriptlets/pkilogging.py         |   27 +-
 base/deploy/src/scriptlets/pkimanifest.py        |   90 ++++
 base/deploy/src/scriptlets/pkimessages.py        |   72 ++-
 base/deploy/src/scriptlets/pkiparser.py          |  223 +++++++++
 base/deploy/src/scriptlets/security_databases.py |   21 +-
 base/deploy/src/scriptlets/subsystem_layout.py   |  106 +++++
 base/deploy/src/scriptlets/webserver_layout.py   |  135 ++++++
 15 files changed, 1385 insertions(+), 413 deletions(-)
 create mode 100644 base/deploy/src/scriptlets/convenience_symlinks.py
 create mode 100644 base/deploy/src/scriptlets/explode_war.py
 delete mode 100644 base/deploy/src/scriptlets/instance.py
 create mode 100644 base/deploy/src/scriptlets/instance_layout.py
 create mode 100644 base/deploy/src/scriptlets/pkimanifest.py
 create mode 100644 base/deploy/src/scriptlets/pkiparser.py
 create mode 100644 base/deploy/src/scriptlets/subsystem_layout.py
 create mode 100644 base/deploy/src/scriptlets/webserver_layout.py

diff --git a/base/deploy/CMakeLists.txt b/base/deploy/CMakeLists.txt
index 65c3eac..975b32e 100644
--- a/base/deploy/CMakeLists.txt
+++ b/base/deploy/CMakeLists.txt
@@ -34,13 +34,19 @@ execute_process(
 )
 install(
     FILES
-        src/scriptlets/instance.py
+        src/scriptlets/convenience_symlinks.py
+        src/scriptlets/explode_war.py
+        src/scriptlets/instance_layout.py
         src/scriptlets/pkiconfig.py
         src/scriptlets/pkihelper.py
-        src/scriptlets/pkimessages.py
         src/scriptlets/pkilogging.py
+        src/scriptlets/pkimanifest.py
+        src/scriptlets/pkimessages.py
+        src/scriptlets/pkiparser.py
         src/scriptlets/pkiscriptlet.py
         src/scriptlets/security_databases.py
+        src/scriptlets/subsystem_layout.py
+        src/scriptlets/webserver_layout.py
     DESTINATION
         ${PYTHON_SITE_PACKAGES}/pki/deployment
     PERMISSIONS
@@ -84,22 +90,36 @@ install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/d
 install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/tps)")
 
 # generate and install symbolic links for pkispawn CA
-install(
-    CODE
-        "execute_process(
-            COMMAND
-                ${CMAKE_COMMAND} -E create_symlink
-                \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance.py\"
-                \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0010_instance\")"
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0010_instance_layout\")"
 )
-install(
-    CODE
-        "execute_process(
-            COMMAND
-                ${CMAKE_COMMAND} -E create_symlink
-                    \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
-                    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0020_security_databases\")"
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/webserver_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0020_webserver_layout\")"
 )
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0030_subsystem_layout\")"
+)
+#install(CODE "execute_process(COMMAND
+#    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/explode_war.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0040_explode_war\")"
+#)
+#install(CODE "execute_process(COMMAND
+#    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/convenience_symlinks.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0050_convenience_symlinks\")"
+#)
+#install(CODE "execute_process(COMMAND
+##    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/ca/0060_security_databases\")"
+#)
 
 # generate and install symbolic links for pkispawn KRA
 
@@ -113,6 +133,37 @@ install(
 
 
 # generate and install symbolic links for pkidestroy CA
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/instance_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9990_instance_layout\")"
+)
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/webserver_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9980_webserver_layout\")"
+)
+install(CODE "execute_process(COMMAND
+    ${CMAKE_COMMAND} -E create_symlink
+    \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
+    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9970_subsystem_layout\")"
+)
+#install(CODE "execute_process(COMMAND
+#    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/explode_war.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9960_explode_war\")"
+#)
+#install(CODE "execute_process(COMMAND
+#    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/convenience_symlinks.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9950_convenience_symlinks\")"
+#)
+#install(CODE "execute_process(COMMAND
+#    ${CMAKE_COMMAND} -E create_symlink
+#    \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+#    \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/ca/9940_security_databases\")"
+#)
+
 
 # generate and install symbolic links for pkidestroy KRA
 
diff --git a/base/deploy/config/pkideployment.cfg b/base/deploy/config/pkideployment.cfg
index db9ce54..3ac60cd 100644
--- a/base/deploy/config/pkideployment.cfg
+++ b/base/deploy/config/pkideployment.cfg
@@ -1,5 +1,8 @@
 [Common]
 pki_instance_root=/var/lib/pki
+pki_instance_configuration_root=/etc/pki
+pki_instance_log_root=/var/log/pki
+pki_instance_registry_root=/etc/sysconfig/pki
 pki_instance_name=instance
 pki_user=pkiuser
 pki_group=pkiuser
diff --git a/base/deploy/src/pkidestroy b/base/deploy/src/pkidestroy
index a762e14..f58ea5e 100755
--- a/base/deploy/src/pkidestroy
+++ b/base/deploy/src/pkidestroy
@@ -30,8 +30,9 @@ try:
     import logging
     import os
     import pprint
+    from time import strftime as date
     from pki.deployment import pkiconfig as config
-    from pki.deployment import pkihelper
+    from pki.deployment import pkiparser as parse
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
 except ImportError:
@@ -52,18 +53,27 @@ def main(argv):
     if not os.geteuid() == 0:
         sys.exit("'%s' must be run as root!" % argv[0])
 
+    # Generate a timestamp
+    timestamp = date('%Y%m%d%H%M%S')
+
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
 
     # Read and process command-line arguments.
-    pkihelper.process_command_line_arguments(argv)
+    parse.process_command_line_arguments(argv)
 
     # Enable 'pkidestroy' logging.
-    config.pki_log_dir = config.pki_root_prefix +\
-                         config.PKIDESTROY_LOG_PATH
-    config.pki_log_name = config.PKIDESTROY_LOG_PREFIX +\
-                          config.pki_subsystem.lower() +\
-                          config.PKIDESTROY_LOG_SUFFIX
+    if not config.pki_dry_run_flag:
+        config.pki_log_dir = config.pki_root_prefix +\
+                             config.PKIDESTROY_LOG_PATH
+        config.pki_log_name = config.PKIDESTROY_LOG_PREFIX +\
+                              config.pki_subsystem.lower() +\
+                              config.PKIDESTROY_LOG_SUFFIX + "." +\
+                              timestamp + "." +\
+                              config.PKI_DEPLOYMENT_LOG_EXTENSION
+    else:
+        config.pki_log_dir = config.PKI_DEPLOYMENT_DEFAULT_LOG_PATH
+        config.pki_log_name = config.PKI_DEPLOYMENT_DEFAULT_LOG_NAME
     rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                       config.pki_log_name,
                                       config.pki_log_level,
@@ -76,17 +86,24 @@ def main(argv):
         sys.exit(1)
 
     # Read the specified PKI configuration file.
-    rv = pkihelper.read_pki_configuration_file()
+    rv = parse.read_pki_configuration_file()
     if rv != 0:
-        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv)
+        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     else:
-        config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-        config.pki_log.debug(pp.pformat(config.pki_common_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-        config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+        config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Override PKI configuration file values with 'custom' command-line values.
     if not config.pki_instance_name is None:
@@ -101,26 +118,34 @@ def main(argv):
     if not config.pki_ajp_port is None:
         config.pki_web_server_dict['pki_ajp_port'] =\
             config.pki_ajp_port
-    config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-    config.pki_log.debug(pp.pformat(config.pki_common_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-    config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Combine the various sectional dictionaries into a PKI master dictionary
-    pkihelper.create_pki_master_dictionary()
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    parse.create_pki_master_dictionary()
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Remove the specified PKI subsystem.
-    pki_scriptlets_path = config.pki_root_prefix +\
-                          config.PKIDESTROY_PATH +\
+    pki_scriptlets_path = config.PKIDESTROY_PATH +\
                           "/" + config.pki_subsystem.lower()
     if not os.path.exists(pki_scriptlets_path) or\
        not os.path.isdir(pki_scriptlets_path):
         config.pki_log.error(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                             pki_scriptlets_path)
+                             pki_scriptlets_path,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     pki_subsystem_scriptlets = os.listdir(pki_scriptlets_path)
     pki_subsystem_scriptlets.sort()
@@ -129,7 +154,8 @@ def main(argv):
     rv = 0
     config.pki_log.info(log.PKIDESTROY_BEGIN_MESSAGE_2,
                         config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
+                        config.pki_master_dict['pki_instance_name'],
+                        extra=config.PKI_INDENTATION_LEVEL_0)
     for pki_scriptlet in pki_subsystem_scriptlets:
         scriptlet = __import__(config.PKI_DEPLOYMENT_SCRIPTLETS_MODULE +\
                                '.' + pki_scriptlet[5:],
@@ -140,9 +166,12 @@ def main(argv):
             sys.exit(1)
     config.pki_log.info(log.PKIDESTROY_END_MESSAGE_2,
                         config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+                        config.pki_master_dict['pki_instance_name'],
+                        extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                                    extra=config.PKI_INDENTATION_LEVEL_0)
 
 
 # PKI Deployment Entry Point
diff --git a/base/deploy/src/pkispawn b/base/deploy/src/pkispawn
index a48a475..8e99328 100755
--- a/base/deploy/src/pkispawn
+++ b/base/deploy/src/pkispawn
@@ -30,10 +30,12 @@ try:
     import logging
     import os
     import pprint
+    from time import strftime as date
     from pki.deployment import pkiconfig as config
-    from pki.deployment import pkihelper
+    from pki.deployment import pkiparser as parse
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
+    from pki.deployment import pkimanifest as manifest
 except ImportError:
     print >> sys.stderr, """\
 There was a problem importing one of the required Python modules. The
@@ -55,35 +57,52 @@ def main(argv):
     # Set the umask
     os.umask(config.PKI_DEPLOYMENT_DEFAULT_UMASK)
 
+    # Generate a timestamp
+    timestamp = date('%Y%m%d%H%M%S')
+
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
 
     # Read and process command-line arguments.
-    pkihelper.process_command_line_arguments(argv)
+    parse.process_command_line_arguments(argv)
 
     # Enable 'pkispawn' logging.
     rv = 0
     if not config.pki_update_flag:
+        action = config.PKISPAWN
         pki_deployment_begin = log.PKISPAWN_BEGIN_MESSAGE_2
         pki_deployment_end = log.PKISPAWN_END_MESSAGE_2
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKISPAWN_LOG_PATH
-        config.pki_log_name = config.PKISPAWN_LOG_PREFIX +\
-                              config.pki_subsystem.lower() +\
-                              config.PKISPAWN_LOG_SUFFIX
+        if not config.pki_dry_run_flag:
+            config.pki_log_dir = config.pki_root_prefix +\
+                                 config.PKISPAWN_LOG_PATH
+            config.pki_log_name = config.PKISPAWN_LOG_PREFIX +\
+                                  config.pki_subsystem.lower() +\
+                                  config.PKISPAWN_LOG_SUFFIX + "." +\
+                                  timestamp + "." +\
+                                  config.PKI_DEPLOYMENT_LOG_EXTENSION
+        else:
+            config.pki_log_dir = config.PKI_DEPLOYMENT_DEFAULT_LOG_PATH
+            config.pki_log_name = config.PKI_DEPLOYMENT_DEFAULT_LOG_NAME
         rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                           config.pki_log_name,
                                           config.pki_log_level,
                                           config.pki_console_log_level,
                                           config.PKISPAWN_LOGGER)
     else:
+        action = config.PKIRESPAWN
         pki_deployment_begin = log.PKIRESPAWN_BEGIN_MESSAGE_2
         pki_deployment_end = log.PKIRESPAWN_END_MESSAGE_2
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKIRESPAWN_LOG_PATH
-        config.pki_log_name = config.PKIRESPAWN_LOG_PREFIX +\
-                              config.pki_subsystem.lower() +\
-                              config.PKIRESPAWN_LOG_SUFFIX
+        if not config.pki_dry_run_flag:
+            config.pki_log_dir = config.pki_root_prefix +\
+                                 config.PKIRESPAWN_LOG_PATH
+            config.pki_log_name = config.PKIRESPAWN_LOG_PREFIX +\
+                                  config.pki_subsystem.lower() +\
+                                  config.PKIRESPAWN_LOG_SUFFIX + "." +\
+                                  timestamp + "." +\
+                                  config.PKI_DEPLOYMENT_LOG_EXTENSION
+        else:
+            config.pki_log_dir = config.PKI_DEPLOYMENT_DEFAULT_LOG_PATH
+            config.pki_log_name = config.PKI_DEPLOYMENT_DEFAULT_LOG_NAME
         rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                           config.pki_log_name,
                                           config.pki_log_level,
@@ -96,17 +115,24 @@ def main(argv):
         sys.exit(1)
 
     # Read the specified PKI configuration file.
-    rv = pkihelper.read_pki_configuration_file()
+    rv = parse.read_pki_configuration_file()
     if rv != 0:
-        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv)
+        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     else:
-        config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-        config.pki_log.debug(pp.pformat(config.pki_common_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-        config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+        config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Override PKI configuration file values with 'custom' command-line values.
     if not config.pki_instance_name is None:
@@ -121,26 +147,34 @@ def main(argv):
     if not config.pki_ajp_port is None:
         config.pki_web_server_dict['pki_ajp_port'] =\
             config.pki_ajp_port
-    config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-    config.pki_log.debug(pp.pformat(config.pki_common_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-    config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Combine the various sectional dictionaries into a PKI master dictionary
-    pkihelper.create_pki_master_dictionary()
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    parse.create_pki_master_dictionary()
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Install and configure the specified PKI subsystem.
-    pki_scriptlets_path = config.pki_root_prefix +\
-                          config.PKISPAWN_PATH +\
+    pki_scriptlets_path = config.PKISPAWN_PATH +\
                           "/" + config.pki_subsystem.lower()
     if not os.path.exists(pki_scriptlets_path) or\
        not os.path.isdir(pki_scriptlets_path):
         config.pki_log.error(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                             pki_scriptlets_path)
+                             pki_scriptlets_path,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     pki_subsystem_scriptlets = os.listdir(pki_scriptlets_path)
     pki_subsystem_scriptlets.sort()
@@ -149,7 +183,8 @@ def main(argv):
     rv = 0
     config.pki_log.info(pki_deployment_begin,
                         config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
+                        config.pki_master_dict['pki_instance_name'],
+                        extra=config.PKI_INDENTATION_LEVEL_0)
     for pki_scriptlet in pki_subsystem_scriptlets:
         scriptlet = __import__(config.PKI_DEPLOYMENT_SCRIPTLETS_MODULE +\
                                '.' + pki_scriptlet[5:],
@@ -161,11 +196,31 @@ def main(argv):
             rv = instance.respawn()
         if rv != 0:
             sys.exit(1)
+
+    # Save a timestamped copy of the installation/update manifest file
+    filename = config.pki_root_prefix +\
+               config.pki_master_dict['pki_instance_registry_root'] + "/" +\
+               config.pki_master_dict['pki_instance_name'] + "/" +\
+               config.pki_master_dict['pki_subsystem'].lower() +"/" +\
+               action + "_" + config.PKI_MANIFEST + "." +\
+               timestamp + "." + config.PKI_DEPLOYMENT_CSV_EXTENSION
+    config.pki_log.info(log.PKI_MANIFEST_MESSAGE_1, filename,
+                        extra=config.PKI_INDENTATION_LEVEL_1)
+    # for record in manifest.database:
+    #     print tuple(record)
+    if not config.pki_dry_run_flag:
+        manifest.file.register(filename)
+        manifest.file.write()
+
+    # Log final process messages
     config.pki_log.info(pki_deployment_end,
                         config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+                        config.pki_master_dict['pki_instance_name'],
+                        extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
 
 # PKI Deployment Entry Point
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
new file mode 100644
index 0000000..bcaf181
--- /dev/null
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -0,0 +1,124 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2011 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    # instance base
+    pki_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_root']
+    pki_instance_path = pki_path + "/" +\
+        config.pki_master_dict['pki_instance_name']
+
+    # instance logs
+    pki_log_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_log_root']
+    pki_instance_log_path = pki_log_path + "/" +\
+        config.pki_master_dict['pki_instance_name']
+
+    # instance configuration
+    pki_configuration_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_configuration_root']
+    pki_instance_configuration_path = pki_configuration_path + "/" +\
+        config.pki_master_dict['pki_instance_name']
+
+    # instance registry
+    pki_registry_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_registry_root']
+    pki_instance_registry_path = pki_registry_path + "/" +\
+        config.pki_master_dict['pki_instance_name']
+
+    def spawn(self):
+        config.pki_log.info(log.INSTANCE_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish 'uid' and 'gid'
+        util.identity.set_uid(config.pki_master_dict['pki_user'])
+        util.identity.set_gid(config.pki_master_dict['pki_group'])
+        # establish instance base
+        util.directory.create(self.pki_path)
+        util.directory.create(self.pki_instance_path)
+        # establish instance logs
+        util.directory.create(self.pki_log_path)
+        util.directory.create(self.pki_instance_log_path)
+        # establish instance configuration
+        if self.pki_configuration_path != config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.create(self.pki_configuration_path)
+        util.directory.create(self.pki_instance_configuration_path)
+        # establish instance registry
+        util.directory.create(self.pki_registry_path)
+        util.directory.create(self.pki_instance_registry_path)
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.INSTANCE_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish 'uid' and 'gid'
+        util.identity.set_uid(config.pki_master_dict['pki_user'])
+        util.identity.set_gid(config.pki_master_dict['pki_group'])
+        # update instance base
+        util.directory.modify(self.pki_path)
+        util.directory.modify(self.pki_instance_path)
+        # update instance logs
+        util.directory.modify(self.pki_log_path)
+        util.directory.modify(self.pki_instance_log_path)
+        # update instance configuration
+        if self.pki_configuration_path != config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.modify(self.pki_configuration_path)
+        util.directory.modify(self.pki_instance_configuration_path)
+        # update instance registry
+        util.directory.modify(self.pki_registry_path)
+        util.directory.modify(self.pki_instance_registry_path)
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.INSTANCE_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # remove instance base
+        if util.directory.is_empty(self.pki_instance_path):
+            util.directory.delete(self.pki_instance_path)
+        if util.directory.is_empty(self.pki_path):
+            util.directory.delete(self.pki_path)
+        # remove instance logs
+        if util.directory.is_empty(self.pki_instance_log_path):
+            util.directory.delete(self.pki_instance_log_path)
+        if util.directory.is_empty(self.pki_log_path):
+            util.directory.delete(self.pki_log_path)
+        # remove instance configuration
+        if util.directory.is_empty(self.pki_instance_configuration_path):
+            util.directory.delete(self.pki_instance_configuration_path)
+        if util.directory.is_empty(self.pki_configuration_path) and\
+           self.pki_configuration_path != config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.delete(self.pki_configuration_path)
+        # remove instance registry
+        if util.directory.is_empty(self.pki_instance_registry_path):
+            util.directory.delete(self.pki_instance_registry_path)
+        if util.directory.is_empty(self.pki_registry_path):
+            util.directory.delete(self.pki_registry_path)
+        return self.rv
+
